// ClienteCOMDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ClienteCOM.h"
#include "ClienteCOMDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClienteCOMDlg dialog

CClienteCOMDlg::CClienteCOMDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClienteCOMDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClienteCOMDlg)
	m_op1 = 0;
	m_op2 = 0;
	m_res = 0;
	m_txt1 = _T("");
	m_txt2 = _T("");
	m_res3 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClienteCOMDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClienteCOMDlg)
	DDX_Text(pDX, IDC_EDIT_OP1, m_op1);
	DDX_Text(pDX, IDC_EDIT_OP2, m_op2);
	DDX_Text(pDX, IDC_EDIT_RES, m_res);
	DDX_Text(pDX, IDC_EDIT_TXT1, m_txt1);
	DDX_Text(pDX, IDC_EDIT_TXT2, m_txt2);
	DDX_Text(pDX, IDC_EDIT_RES3, m_res3);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CClienteCOMDlg, CDialog)
	//{{AFX_MSG_MAP(CClienteCOMDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUT_ADICAO, OnButAdicao)
	ON_BN_CLICKED(IDC_BUT_ADDU, OnButAddu)
	ON_BN_CLICKED(IDC_BUT_ADDU2, OnButAddu2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClienteCOMDlg message handlers

BOOL CClienteCOMDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CClienteCOMDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClienteCOMDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClienteCOMDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CClienteCOMDlg::OnButAdicao() 
{
	UpdateData();

	::TESTECOMLib::IOperacoesPtr spOper;

	try{

		TESTEHR( spOper.CreateInstance( __uuidof(::TESTECOMLib::Operacoes) ) );
		
		TESTEHR( spOper->Adicao( m_op1, m_op2, &m_res ) );

		UpdateData(FALSE);

	}
	catch(_com_error &e)
	{
		::MessageBox(NULL,e.ErrorMessage(),"COM ERROR!",MB_ICONSTOP|MB_OK);
	}
}

void CClienteCOMDlg::OnButAddu() 
{
	UpdateData();

	::TESTECOMLib::IOperacoesPtr spOper;
	VARIANT vRes;

	try{

		TESTEHR( spOper.CreateInstance( __uuidof(::TESTECOMLib::Operacoes) ) );
		
		TESTEHR( spOper->AdicaoU( m_op1, m_op2, &vRes ) );
		
		m_res= _variant_t( vRes );

		UpdateData(FALSE);

	}
	catch(_com_error &e)
	{
		::MessageBox(NULL,e.ErrorMessage(),"COM ERROR!",MB_ICONSTOP|MB_OK);
	}
}

void CClienteCOMDlg::OnButAddu2() 
{
UpdateData();

	::TESTECOMLib::IOperacoesPtr spOper;
	VARIANT vRes;

	try{

		TESTEHR( spOper.CreateInstance( __uuidof(::TESTECOMLib::Operacoes) ) );
		
		TESTEHR( spOper->AdicaoU( m_txt1.AllocSysString(), m_txt2.AllocSysString(), &vRes ) );
		
		m_res3= CString( _variant_t( vRes ).bstrVal );

		UpdateData(FALSE);

	}
	catch(_com_error &e)
	{
		::MessageBox(NULL,e.ErrorMessage(),"COM ERROR!",MB_ICONSTOP|MB_OK);
	}	
}
